/// @cond EO_CXX_EO_IMPL

inline void evas_3d_scene::size_set(int w_, int h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_size_set(w_, h_));
}

inline void evas_3d_scene::size_get(int* w_, int* h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_size_get(w_, h_));
}

inline void evas_3d_scene::background_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_background_color_set(r_, g_, b_, a_));
}

inline void evas_3d_scene::background_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_background_color_get(r_, g_, b_, a_));
}

inline bool evas_3d_scene::pick(Evas_Real x_, Evas_Real y_, Evas_3D_Node ** node_, Evas_3D_Mesh ** mesh_, Evas_Real* s_, Evas_Real* t_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_pick(x_, y_, node_, mesh_, s_, t_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Evas_3D_Node * evas_3d_scene::exist(Evas_Real x_, Evas_Real y_, Evas_3D_Node * node_) const
{
   Evas_3D_Node * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_exist(x_, y_, node_));
   return _tmp_ret;
}

inline ::efl::eina::range_list< Evas_3D_Node * > evas_3d_scene::pick_member_list_get(Evas_Real x_, Evas_Real y_) const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_pick_member_list_get(x_, y_));
   return ::efl::eolian::to_cxx<::efl::eina::range_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline void evas_3d_scene::shadows_enable_set(bool shadows_enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_shadows_enable_set(::efl::eolian::to_c(shadows_enabled_)));
}

inline bool evas_3d_scene::shadows_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_shadows_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool evas_3d_scene::color_pick_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_color_pick_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool evas_3d_scene::color_pick_enable_set(bool color_pick_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_color_pick_enable_set(::efl::eolian::to_c(color_pick_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Evas_3D_Node * evas_3d_scene::root_node_get() const
{
   Evas_3D_Node * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_root_node_get());
   return _tmp_ret;
}

inline void evas_3d_scene::root_node_set(Evas_3D_Node * node_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_root_node_set(node_));
}

inline Evas_3D_Node * evas_3d_scene::camera_node_get() const
{
   Evas_3D_Node * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_camera_node_get());
   return _tmp_ret;
}

inline void evas_3d_scene::camera_node_set(Evas_3D_Node * node_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_camera_node_set(node_));
}

inline void eo_cxx::evas_3d_scene::size_set(int w_, int h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_size_set(w_, h_));
}

inline void eo_cxx::evas_3d_scene::size_get(int* w_, int* h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_size_get(w_, h_));
}

inline void eo_cxx::evas_3d_scene::background_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_background_color_set(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_scene::background_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_background_color_get(r_, g_, b_, a_));
}

inline bool eo_cxx::evas_3d_scene::pick(Evas_Real x_, Evas_Real y_, Evas_3D_Node ** node_, Evas_3D_Mesh ** mesh_, Evas_Real* s_, Evas_Real* t_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_pick(x_, y_, node_, mesh_, s_, t_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Evas_3D_Node * eo_cxx::evas_3d_scene::exist(Evas_Real x_, Evas_Real y_, Evas_3D_Node * node_) const
{
   Evas_3D_Node * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_exist(x_, y_, node_));
   return _tmp_ret;
}

inline ::efl::eina::range_list< Evas_3D_Node * > eo_cxx::evas_3d_scene::pick_member_list_get(Evas_Real x_, Evas_Real y_) const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_pick_member_list_get(x_, y_));
   return ::efl::eolian::to_cxx<::efl::eina::range_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline void eo_cxx::evas_3d_scene::shadows_enable_set(bool shadows_enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_shadows_enable_set(::efl::eolian::to_c(shadows_enabled_)));
}

inline bool eo_cxx::evas_3d_scene::shadows_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_shadows_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::evas_3d_scene::color_pick_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_color_pick_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::evas_3d_scene::color_pick_enable_set(bool color_pick_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_color_pick_enable_set(::efl::eolian::to_c(color_pick_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Evas_3D_Node * eo_cxx::evas_3d_scene::root_node_get() const
{
   Evas_3D_Node * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_root_node_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_scene::root_node_set(Evas_3D_Node * node_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_root_node_set(node_));
}

inline Evas_3D_Node * eo_cxx::evas_3d_scene::camera_node_get() const
{
   Evas_3D_Node * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_scene_camera_node_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_scene::camera_node_set(Evas_3D_Node * node_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_scene_camera_node_set(node_));
}

inline ::eo_cxx::evas_3d_scene::operator ::evas_3d_scene() const
{
   return *static_cast<::evas_3d_scene const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas_3d_scene::operator ::evas_3d_scene&()
{
   return *static_cast<::evas_3d_scene*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas_3d_scene::operator ::evas_3d_scene const&() const
{
   return *static_cast<::evas_3d_scene const*>(static_cast<void const*>(this));
}

template <typename T>
void _evas_3d_scene_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int w_, int h_)
{
   try
      {
         static_cast<T*>(self->this_)->size_set(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_scene_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   try
      {
         static_cast<T*>(self->this_)->size_get(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_scene_background_color_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   try
      {
         static_cast<T*>(self->this_)->background_color_set(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_scene_background_color_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   try
      {
         static_cast<T*>(self->this_)->background_color_get(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_scene_pick_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_, Evas_3D_Node ** node_, Evas_3D_Mesh ** mesh_, Evas_Real* s_, Evas_Real* t_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->pick(x_, y_, node_, mesh_, s_, t_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
Evas_3D_Node * _evas_3d_scene_exist_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_, Evas_3D_Node * node_)
{
   Evas_3D_Node * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->exist(x_, y_, node_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
::efl::eina::range_list< Evas_3D_Node * > _evas_3d_scene_pick_member_list_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_)
{
   ::efl::eina::range_list< Evas_3D_Node * > _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->pick_member_list_get(x_, y_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_scene_shadows_enable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool shadows_enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->shadows_enable_set(::efl::eolian::to_cxx<bool>(shadows_enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_scene_shadows_enable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->shadows_enable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
bool _evas_3d_scene_color_pick_enable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->color_pick_enable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
bool _evas_3d_scene_color_pick_enable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool color_pick_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->color_pick_enable_set(::efl::eolian::to_cxx<bool>(color_pick_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
Evas_3D_Node * _evas_3d_scene_root_node_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Node * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->root_node_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_scene_root_node_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Node * node_)
{
   try
      {
         static_cast<T*>(self->this_)->root_node_set(node_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Node * _evas_3d_scene_camera_node_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Node * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->camera_node_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_scene_camera_node_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Node * node_)
{
   try
      {
         static_cast<T*>(self->this_)->camera_node_set(node_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_scene >
{
   template <typename T>
   struct type
         : virtual operations< ::evas_3d_object >::template type<T>
         , virtual operations< ::evas::common_interface >::template type<T>
   {
      virtual void size_set(int w_, int h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_size_set(w_, h_));
      }

      virtual void size_get(int* w_, int* h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_size_get(w_, h_));
      }

      virtual void background_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_background_color_set(r_, g_, b_, a_));
      }

      virtual void background_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_background_color_get(r_, g_, b_, a_));
      }

      virtual bool pick(Evas_Real x_, Evas_Real y_, Evas_3D_Node ** node_, Evas_3D_Mesh ** mesh_, Evas_Real* s_, Evas_Real* t_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_pick(x_, y_, node_, mesh_, s_, t_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Evas_3D_Node * exist(Evas_Real x_, Evas_Real y_, Evas_3D_Node * node_)
      {
         Evas_3D_Node * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_exist(x_, y_, node_));
            return _tmp_ret;
      }

      virtual ::efl::eina::range_list< Evas_3D_Node * > pick_member_list_get(Evas_Real x_, Evas_Real y_)
      {
         Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_pick_member_list_get(x_, y_));
            return ::efl::eolian::to_cxx<::efl::eina::range_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual void shadows_enable_set(bool shadows_enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_shadows_enable_set(::efl::eolian::to_c(shadows_enabled_)));
      }

      virtual bool shadows_enable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_shadows_enable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool color_pick_enable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_color_pick_enable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool color_pick_enable_set(bool color_pick_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_color_pick_enable_set(::efl::eolian::to_c(color_pick_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Evas_3D_Node * root_node_get()
      {
         Evas_3D_Node * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_root_node_get());
            return _tmp_ret;
      }

      virtual void root_node_set(Evas_3D_Node * node_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_root_node_set(node_));
      }

      virtual Evas_3D_Node * camera_node_get()
      {
         Evas_3D_Node * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_camera_node_get());
            return _tmp_ret;
      }

      virtual void camera_node_set(Evas_3D_Node * node_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_camera_node_set(node_));
      }

   };
};


#ifdef EVAS_3D_SCENE_PROTECTED
template<>
struct operation_description_class_size< ::evas_3d_scene >
{
   static constexpr int value = 15 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value;
};

#else
template<>
struct operation_description_class_size< ::evas_3d_scene >
{
   static constexpr int value = 15 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value;
};

#endif

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas_3d_scene>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_scene_size_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_size_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_scene_size_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_size_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_scene_background_color_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_background_color_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_scene_background_color_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_background_color_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_scene_pick_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_pick);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_scene_exist_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_exist);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_scene_pick_member_list_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_pick_member_list_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_scene_shadows_enable_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_shadows_enable_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_scene_shadows_enable_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_shadows_enable_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_scene_color_pick_enable_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_color_pick_enable_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_evas_3d_scene_color_pick_enable_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_color_pick_enable_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_evas_3d_scene_root_node_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_root_node_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_evas_3d_scene_root_node_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_root_node_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_evas_3d_scene_camera_node_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_camera_node_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_evas_3d_scene_camera_node_set_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_camera_node_set);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas_3d_object>(), &ops[operation_description_class_size< ::evas_3d_scene >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::common_interface>(), &ops[operation_description_class_size< ::evas_3d_scene >::value + operation_description_class_size<::evas_3d_object>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::evas_3d_scene>)
{
   return (EVAS_3D_SCENE_CLASS);
}

} } }

/// @endcond

